#include <iostream.h>
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>
#include "figura.h"
#include "rectangulo.h"
#include "circulo.h"
#include "elipse.h"
#include "coche.h"
#include "rapido.h"

rapido::rapido(int x, int y):coche(x,y)
{
	//cout<<"Ha entrado en el contructor coche rapido parametrizado";
   //getchar();

	this->x=x;
   this->y=y;

   v_figuras[0]=new circulo(x-20,y-30,15,6);      		//Ruedas
   v_figuras[1]=new circulo(x+20,y-30,15,6);
   v_figuras[2]=new circulo(x-20,y+30,15,6);
   v_figuras[3]=new circulo(x+20,y+30,15,6);
   v_figuras[4]=new elipse(x-10,y-45,15,0,360,6,3);	//Faros
   v_figuras[5]=new elipse(x+10,y-45,15,0,360,6,3);
   v_figuras[6]=new elipse(x,y,4,0,360,20,50);     	//Carrocera

	vel_vert=15;
}

void rapido::operator --(void)
{
	//cout<<"Operador sobrecargado -- "<<endl;
   v_figuras[1]->set_color(0);
   v_figuras[1]->pintar();
}

void rapido::set_vel_horiz(int v)
{
	vel_horiz=v;
}

void rapido::set_gasolina(int g)
{
	gasolina=g;
}

rapido::~rapido()
{
	//cout<<"Ha entrado en el destructor coche rapido";
   //getchar();

	for (int i=0;i<7;i++)
   {
   	delete v_figuras[i];
   }
}

void rapido::pintar()
{
	//cout<<"Ha entrado en el metodo pintar coche rapido";
   //getchar();
	for (int i=0; i<7;i++)		v_figuras[i]->pintar();
}

void rapido::borrar()
{
	for (int i =0; i<7;i++)		v_figuras[i]->borrar();
}

void rapido::mover(int tecla)
{
	borrar();				//Borrar coche

   if (tecla==77)			//Tecla derecha
   					{
                     if (x<605)
   							{
									x+=vel_horiz;
                  			for (int i =0; i<7;i++)		v_figuras[i]->set_x(v_figuras[i]->get_x()+vel_horiz);
                        }
                  }
   if (tecla==75)			//Tecla izquierda
   					{
                  	if (x>190)
   							{
									x=x-vel_horiz;
									for (int i=0; i<7; i++)		v_figuras[i]->set_x(v_figuras[i]->get_x()-vel_horiz);
                        }
                  }
   if (tecla==72)			//Tecla arriba
   					{
                  	if (y>60)
   							{
									y=y-vel_vert;
									for (int i=0; i<7; i++) 	v_figuras[i]->set_y(v_figuras[i]->get_y()-vel_vert);
                        }
                  }
   if (tecla==80)			//Tecla abajo
   					{
                  	if (y<420)
   							{
									y=y+vel_vert;
									for (int i=0; i<7; i++) 	v_figuras[i]->set_y(v_figuras[i]->get_y()+vel_vert);
                        }
                  }

   pintar();
}

