#include <iostream.h>
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <typeinfo.h>
#include <graphics.h>
#include "figura.h"
#include "rectangulo.h"
#include "circulo.h"
#include "elipse.h"
#include "objeto.h"
#include "bonificacion.h"
#include "estatua.h"
#include "vasija.h"
#include "bache.h"
#include "accidente.h"
#include "lista.h"
#include "segmento.h"

segmento::segmento(int xs,int ys, int col, int xi, int yi):rectangulo(xs,ys,col,xi,yi)
{
	//cout<<"Constructor parametrizado de segmento"<<endl;

   carretera=new rectangulo(xs,ys,col,xi,yi);
   lista_objetos=new lista<objeto>();
}

segmento::segmento(const segmento&original):rectangulo(original)
{
	//cout<<"Ha entrado en el constructor copia de segmento ...";
   //getchar();
   carretera = new rectangulo(*((rectangulo *)original.carretera));
   lista_objetos = new lista<objeto>();

   while (original.lista_objetos->noesfin())
   	{
   		p_obj_aux=original.lista_objetos->leer();

      	if (typeid(*(p_obj_aux))==typeid(accidente))
         	{
            	copia_obj=new accidente(*((accidente *)p_obj_aux));   //copiando objeto accidente
               lista_objetos->insertar(copia_obj);                   //insertando en la lista de la copia
         	}
     		if (typeid(*(p_obj_aux))==typeid(vasija))
         	{
            	copia_obj=new vasija(*((vasija *)p_obj_aux));   		//copiando objeto vasija
               lista_objetos->insertar(copia_obj);             		//insertando en la lista de la copia
         	}
     		if (typeid(*(p_obj_aux))==typeid(bache))
         	{
            	copia_obj=new bache(*((bache *)p_obj_aux));   		//copiando objeto bache
               lista_objetos->insertar(copia_obj);           		//insertando en la lista de la copia
         	}
         if (typeid(*(p_obj_aux))==typeid(estatua))
         	{
            	copia_obj=new estatua(*((estatua *)p_obj_aux));   	//copiando objeto estatua
               lista_objetos->insertar(copia_obj);             	//insertando en la lista de la copia
         	}

         original.lista_objetos->avanzar();

     	}
}

lista<objeto> * segmento::darlista()
{
	lista<objeto> *p_list;
   p_list=lista_objetos;
	return p_list;
}

figura * segmento::darcarretera()
{
	figura *p_carretera;
   p_carretera=carretera;
	return p_carretera;
}

segmento::~segmento()
{
	//cout<<"Ha entrado en el destructor segmento"<<endl;
   delete lista_objetos;
   delete carretera;
}
