#ifndef arbol_h
#define arbol_h

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "turista.h"



class arbol

   {
   	private:

   		struct nodo                      	//Definicin de nodo
      		{
      			turista *giri;
         		struct nodo * izq;
            	struct nodo * der;
      		};

      	typedef nodo *pnodo;
      	pnodo arbol, padre, actual, nuevo;  //Punteros de tipo nodo

   public:

      arbol ();     								//Constructor sin parametrizar
      arbol (pnodo aux);                  //Constructor
      bool insertar (turista *t);         //Inserta un turista en el rbol
      bool borrar (turista *t);           //Borra un turista del rbol
      arbol hijoizq ();
      arbol hijoder ();
      bool vacio (pnodo aux);  				//Averigua si el rbol est vaco
      void inorden (pnodo aux);           //Ordenacin inorden

      void guardar(char * fichet);
      void apertura(pnodo auxi, char *fturi);
      void volcado (pnodo aux, ofstream &turistas);

      void busqueda (pnodo aux, char *mm, char *aa);	//Busca en el rbol por fecha
      void mostrar ();                                //Muestra el rbol inorden
      void buscar (char *mm, char *aa);
      turista* raiz (pnodo aux);
   	bool hoja (pnodo aux);
   	int altura (pnodo aux);
   	void muestra_hojas (pnodo aux);
   	int maximo (int n, int m);
	   bool buscanodo (pnodo aux, int dis);
		void mostrar_nivel (int n);
   	void mostrar_nivel_inv (int n);
      ~arbol();

};

#endif
