/***********************************************************
 *	Alumno: Ral J. Zambrano Maestre                        *
 * Asignatura: Labratorio de Progrmacin II                *
 *	Titulacin: I. T. Informtica de Gestin                *
 * Curso: 2007-2008                                        *
 * Fecha cracin: 10 de Marzo de 2008                      *
 *	ltima modificacin: 21 de Agosto de 2008               *
 * Compilador Utilizado: Borland C++ 5.02 para Windows     *
 ***********************************************************/

#include <alloc.h>
#include <iostream.h>
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>
#include <iostream.h>
#include <time.h>
#include <typeinfo.h>
#include <dos.h>
#include <fstream.h>
#include "turista.h"
#include "grafico.h"
#include "figura.h"
#include "rectangulo.h"
#include "circulo.h"
#include "elipse.h"
#include "coche.h"
#include "normal.h"
#include "rapido.h"
#include "objeto.h"
#include "bonificacion.h"
#include "estatua.h"
#include "vasija.h"
#include "bache.h"
#include "accidente.h"
#include "lista.h"
#include "segmento.h"
#include "cola.h"
#include "linea.h"
#include "grafo.h"
#include "arbol.h"
#include "juego.h"
#define MAX 6

/********************************/
/*      Programa principal      */
/********************************/

int main(int argc, char * argv[])
{

	juego *j1=new juego();
   grafico *g1=new grafico();
   arbol *olivo=new arbol();
   coche *p_coche,*pc_normal,*pc_rapido;
   char * name, *nacion, *monumento;
   turista *nuevot, *turi;
   int d,m,a;
   bool visitados[MAX]={true,false,false,false,false,false};
   bool creado_r=false;

  	fstream monument(argv[1],ios::in); 		//Abrimos el fichero monumentos para lectura
	if (!monument)
	{
   	cout<<"Error al abrir el fichero de monumentos "<<argv[1]<<endl;
      getchar();
      exit(1);
   }

  	grafo *gr=new grafo(argv[1]);

	monument.close();							//Cerramos el fichero de monumentos

   linea *lin=new linea();					//Puntero linea

   char *cadena;              			//Puntero a cadena

   fstream turistas(argv[2],ios::in); 		//Abrimos el fichero para lectura
	if (!turistas)
	{
   	cout<<"Error al abrir el fichero de turistas "<<argv[2]<<endl;
      getchar();
      exit(1);
   }
   if ((cadena=new char[200])==NULL)
   {
   	cout<<"Error en la reserva de memoria..";
		getchar();
      exit(1);
   }

	while (!turistas.eof())
   	{
      	cadena[0]='\0';			//Inicializamos la cadena en blanco.
      	turistas>>cadena;       //Leemos una cadena del fichero de turistas
         lin->separar(cadena);   //Separamos los campos de la cadena

         nuevot=new turista(lin->obtener_campo(0),lin->obtener_campo(1));	//Creamos un nuevo turista con los campos nombre y nacionalidad
         d=atoi(lin->obtener_campo(2));  												//Obtenemos el dia de la ultima visita
         m=atoi(lin->obtener_campo(3));                                    //Obtenemos el mes de la ultima visita
         a=atoi(lin->obtener_campo(4));                                    //Obtenemos el ao de la ultima visita
         nuevot->set_fecha(d,m,a);                                         //Le ponemos a ese turista la fecha leida

         int ind=6;		//indice de campos que comienza en el primer monumento visitado (excluye a la O.Turismo)

         while (strlen(lin->obtener_campo(ind))>1)
         	{
               monumento=new char[strlen(lin->obtener_campo(ind))+1];   //Reserva memoria para la cadena
         		strcpy(monumento,lin->obtener_campo(ind));               //Copiamos el campo
         		monumento[strlen(lin->obtener_campo(ind))]='\0';         //Insertamos fin de lnea

               nuevot->set_monumento(monumento);	//inserta el monumento en la lista de visitados

               ind++;
         	}

			olivo->insertar(nuevot);	//Una vez leido todos los campos insertamos el turista en el arbol
      }

   turistas.close();						//Cerramos el fichero de turistas

   g1->pintamenu();

  	bool finalizar=false;
  	while (!finalizar)
   {
     switch (g1->esperarseleccion())
     {
  		case 1:

      	  	g1->pintainstr();
   			g1->pintamenu();
           	break;

      case 2:

      		g1->borramenu();
      		finalizar=true;
            break;

      case 3:

            g1->borramenu();

       		char *mm,*aa;
            mm=new char[2];
            aa=new char[4];
            gotoxy(1,1);
   			cout<<"Busqueda de turistas por fecha: "<<endl;
   			gotoxy(1,3);
   			cout<<"Inserta el mes: ";
   			cin>>mm;
   			gotoxy(1,4);
   			cout<<"Inserta el anio: ";
   			cin>>aa;
            olivo->buscar(mm,aa);

          	g1->borramenu();
            g1->pintamenu();

            break;

      case 4:

            g1->borramenu();

            /* Ocultar raton para finalizar */
  				g1->OcultarRaton();

  				/*Cierre del modo grfico*/
  				closegraph();

  				cout<<"FIN";
  				getchar();
  				return(0);

     }

   }

   g1->borramenu();

   name=new char[20];
   nacion=new char[20];
   name[0]='\0';
	nacion[0]='\0';

   gotoxy(1,1);
   cout<<"Inserta el nombre del turista: ";
   cin>>name;
   gotoxy(1,2);
   cout<<"Inserta la nacionalidad: ";
   cin>>nacion;

   turi=new turista(name,nacion);

   turi->pilla_fecha();

  	pc_normal=new normal(320,420);				//Creamos un coche normal
  	pc_rapido=new rapido(320,420);				//Creamos un coche rapido 

   g1->pintagrafo(gr);

  	bool salir=false;
  	while (!salir)
   {
     int j;
     switch (g1->esperarpulsacion())
     {
  		case 1:

      		j=0;
            p_coche=j1->eligecoche(pc_normal, pc_rapido, turi, creado_r);
				j1->cargar_carrera (g1,gr,p_coche,turi,j,visitados);
     			g1->pintagrafo(gr);
     			break;

      case 2:

            j=1;
           	p_coche=j1->eligecoche(pc_normal, pc_rapido, turi, creado_r);
				j1->cargar_carrera (g1,gr,p_coche,turi,j,visitados);
            g1->pintagrafo(gr);
        		break;

      case 3:

            j=2;
           	p_coche=j1->eligecoche(pc_normal, pc_rapido, turi, creado_r);
				j1->cargar_carrera (g1,gr,p_coche,turi,j,visitados);
		     	g1->pintagrafo(gr);
        		break;

      case 4:

            j=3;
           	p_coche=j1->eligecoche(pc_normal, pc_rapido, turi, creado_r);
				j1->cargar_carrera (g1,gr,p_coche,turi,j,visitados);
  		  		g1->pintagrafo(gr);
        		break;

      case 5:

            j=4;
           	p_coche=j1->eligecoche(pc_normal, pc_rapido, turi, creado_r);
				j1->cargar_carrera (g1,gr,p_coche,turi,j,visitados);
  		  		g1->pintagrafo(gr);
        		break;

      case 6:

            j=5;
           	p_coche=j1->eligecoche(pc_normal, pc_rapido, turi, creado_r);
				j1->cargar_carrera (g1,gr,p_coche,turi,j,visitados);
  		  		g1->pintagrafo(gr);
        		break;

      case 7:

      	 	delete pc_normal;
            delete pc_rapido;
           	//delete p_coche;

      		g1->borramenu();
        		salir=true;

            cout<<"NOMBRE: "<<turi->get_nombre()<<endl;
  		  		cout<<"NACIONALIDAD: "<<turi->get_nacionalidad()<<endl;
  		  		cout<<"PUNTUACION TOTAL: "<<turi->get_puntos()<<endl;
        		turi->mostrar_monumentos();
            getchar();

            olivo->insertar(turi);     //Insertamos el turista en el rbol

            cout<<endl<<"Contenido del arbol..."<<endl;
            olivo->mostrar();

          	g1->borramenu();

        		olivo->guardar(argv[2]);

        		break;
     }

	}


  /* Ocultar raton para finalizar */
  g1->OcultarRaton();

  /*Cierre del modo grfico*/
  closegraph();

  cout<<"FIN";
  getchar();
  return(0);
}
