#ifndef grafo_h
#define grafo_h
#define MAX 6

struct celda
		{
        	public:
              		char* nombre_calle;
              		int   longitud;
		};

typedef char * T_vectornodos[MAX];
typedef celda T_matrizadyacencia[MAX][MAX];

class grafo
   {
      private:

         T_vectornodos VN;
         T_matrizadyacencia M;
        	int vel_horiz,gasolina;
         char * p_origen;

      public:

      	grafo();
         grafo(char * fich);
         bool vacio();
         bool nuevo_arco(char * monumento_origen, char * monumento_destino, char * calle, int distancia);
         bool borrar_arco(char * origen, char * destino);
         void mostrar_nodos();
         char * get_nodo(int i);
         void mostrar_arcos();
         void pintar_arcos();
         bool existe_arco (char * origen, char * destino);
         int get_vel_horiz();
         int get_gasolina();
         void set_p_origen(int i);
         char * get_p_origen();
         int posicion_origen();
         char * get_p_vn(int i);
         char * get_calle(int i, int j);
         ~grafo();

   };

# endif
