#ifndef lista_h
#define lista_h

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>


   template <class datos_lista>
   class lista
   {
      private:

         struct nodo
         {
            datos_lista *info;
            struct nodo *siguiente;
         };

         typedef struct nodo *ptrnodo;

         ptrnodo  cabeza, fin, p_actual, anterior, aux;

      public:

      	lista();
         void crear_lista();
         void insertar(datos_lista *m);
			bool eliminar_actual();
         void eliminar(datos_lista *p);
         void iniciar();
         datos_lista* leer();
         bool noesfin();
         void avanzar();
         bool vacia();
         void borradototal();
         ~lista();

   };


   		template <class datos_lista>
         lista <datos_lista>::lista()
         {
         	cabeza=NULL;
            fin=NULL;
            p_actual=NULL;
            anterior=NULL;
         }


         template <class datos_lista>
			void lista <datos_lista>::crear_lista()
         {
            //cout<<"Creando lista ..."<<endl;
            anterior=NULL;
         	cabeza = NULL;
            fin = NULL;
            p_actual = cabeza;
   		}

         template <class datos_lista>
         void lista <datos_lista>::insertar (datos_lista *m)
         {
      		ptrnodo nuevo;
      		if ((nuevo = new nodo) == NULL)
      		{
         		cout <<"Error en la asignacion de memoria";
         		exit (0);
      		}
      		(*nuevo).info = m;
            (*nuevo).siguiente=NULL;
		      if (vacia ())
      		{
					//cout<<"Insertando el primer elemento de la lista ..."<<endl;
         		p_actual = nuevo;
         		cabeza = nuevo;
         		fin = nuevo;
      		}
      		else
      		{
            	//cout<<"Insertando elemento en la lista ..."<<endl;
         		fin->siguiente=nuevo;
         		fin=nuevo;
      		}
   		}

         template <class datos_lista>
         bool lista <datos_lista>::eliminar_actual()
         {
         	//cout<<"eliminando p_actual..."<<endl;
         	if (p_actual==cabeza)
            {
            	cabeza=cabeza->siguiente;
               delete p_actual->info;
               delete p_actual;
               p_actual=cabeza;
               anterior=NULL;
               return true;
            }
            else
            {
            	if (p_actual==fin)
               	{
                  	fin=anterior;
                     fin->siguiente=NULL;
                     delete p_actual->info;
                     delete p_actual;
                     iniciar();
                     while (p_actual!=fin)
                     	{
                        	anterior=p_actual;
                           p_actual=p_actual->siguiente;
                        }
                     return true;
                  }
               else
               	{
                  	anterior->siguiente=p_actual->siguiente;
                     delete p_actual->info;
                     delete p_actual;
                     p_actual=anterior->siguiente;
                     return true;
                  }
            }
         //return false;
         }

         //No funciona si se le pasa un objeto identico a un elemento de la lista
         //Para ello tendriamos que sobrecargar el operador == para q comparase todos los campos del objeto
         template <class datos_lista>
         void lista <datos_lista>::eliminar (datos_lista *p)
		   {
         	p_actual=cabeza->siguiente;
   			anterior=cabeza;
				while (p_actual!=NULL)
   				{
   					if (p==(cabeza->info))
      					{
                     	//cout<<"Eliminanado nodo..."<<endl;
      						cabeza=cabeza->siguiente;
      						delete anterior;
         					anterior=cabeza;
      					}
   					if ((p_actual->info)==p)
      					{
      						//cout<<"Eliminanado nodo..."<<endl;
      						aux=p_actual->siguiente;
         					delete p_actual;
         					anterior->siguiente=aux;
                     }
               	p_actual=p_actual->siguiente;
      				anterior=anterior->siguiente;
   				}
				if ((p_actual==NULL)&&(anterior!=NULL))
            	{
                  //cout<<"Eliminando ultimo nodo ... Lista vacia"<<endl;
                  delete cabeza;
	              	cabeza=NULL;
   	   	      fin=NULL;
      	   	   p_actual=NULL;

               }
			}

         template <class datos_lista>
         void lista <datos_lista>::iniciar ()
		   {
         	//cout<<"Inicializando la lista al primer elemento ..."<<endl;
      		p_actual = cabeza;
            anterior=NULL;
         }

         template <class datos_lista>
         datos_lista* lista <datos_lista>::leer ()
		   {
      		return p_actual->info;
   		}

         template <class datos_lista>
         bool lista <datos_lista>::noesfin ()
		   {
      		if (p_actual != NULL)
      		{
         		return 1;
      		}
		      else
            {
               return 0;
            }
      	}

         template <class datos_lista>
         void lista <datos_lista>::avanzar()
		   {
               anterior=p_actual;
               p_actual=p_actual->siguiente;

      	}

         template <class datos_lista>
         bool lista <datos_lista> :: vacia ()
		   {
      		return (cabeza == NULL);
   		}

         template <class datos_lista>
         void lista <datos_lista>::borradototal ()
		   {
      		//cout << "Destruyendo lista...\n";
      		ptrnodo aux;
      		while (!vacia ())
      		{
               aux = cabeza -> siguiente;
               delete cabeza->info;
         		delete cabeza;
         		cabeza = aux;
      		}
		      cabeza = NULL;
      		p_actual = NULL;
            anterior=NULL;
      		fin = NULL;
      		//cout <<"Lista destruida..."<<endl;
      		//getchar ();
   		}

         template <class datos_lista>
         lista <datos_lista>::~lista()
         {
				while (!vacia ())		borradototal();
         }

# endif

